package com.bytesw.bytebot.controller;

import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.LegDto;
import com.bytesw.bytebot.model.Leg;
import com.bytesw.bytebot.repository.IItineraryReservationRepository;
import com.bytesw.bytebot.repository.ILegRepository;
import com.bytesw.bytebot.service.FlightService;
import com.bytesw.bytebot.service.LegService;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.service.XDFService;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/service/leg")
public class LegController extends BasicXDFController<LegDto, Long> {



    @Autowired
    private LegService legService;

    @Autowired
    private FlightService flightService;

    @Autowired
    private IItineraryReservationRepository iItineraryReservationRepository;

    @Autowired
    private ILegRepository legRepository;

    @Autowired
    private GsonBuilder gsonBuilder;

    public LegController(LegService legService) {
        super(legService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<LegDto> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<LegDto> value = new DataPage<>();
        value.setData(legService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

    @GetMapping("list/{id}/flights")
    public ResponseEntity<String> listFlightsByLegs(@PathVariable(value = "id") Long id) {
        return new ResponseEntity(flightService.getById(id).getLegs(), HttpStatus.OK);
    }

    @PostMapping("/reservation/{id}")
    public  ResponseEntity<String> addLeg(@PathVariable(value = "id") Long id, @RequestBody Leg legReq) {
        Leg leg = iItineraryReservationRepository.findById(id).map( itineraryReservation -> {
            Long legId = legReq.getId();
            Leg nLeg = legRepository.getOne(legId);
            itineraryReservation.addLeg(nLeg);
            iItineraryReservationRepository.save(itineraryReservation);
            return nLeg;
        }).orElseThrow(null);

        return new ResponseEntity(HttpStatus.OK);
    }


}
