package com.bytesw.bytebot.model;


import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "passengers")
@Getter
@Setter
public class Passenger implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column(name="first_name")
    private String firstName;

    @Column(name="second_name")
    private String secondName;

    @Column(name="last_name")
    private String lastName;

    @Column(name="phone_number")
    private String phoneNumber;

    @Column(name="email_address")
    private String email;

    @Column(name="address_lines")
    private String address;

    @Column(name="city")
    private String city;

    @Column(name="state_province_country")
    private String province;

    @Column(name="country")
    private String country;

    @Column(name="other_passenger_details")
    private String details;

    @OneToMany(mappedBy = "passenger")
    private List<ItineraryReservation> itineraryReservations = new ArrayList<>();

}
