package com.bytesw.bytebot.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Entity
@Table(name = "payments")
@Getter
@Setter
@EqualsAndHashCode
@ToString
public class Payment implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "payment_id")
    private Long id;

    @Column(name = "payment_date")
    @Temporal(TemporalType.TIMESTAMP)
    private Date paymentDate;

    @Column(name = "payment_amount")
    private double paymentAmount;

    @Column(name = "payment_status_code")
    private String status;

    @ManyToMany(fetch = FetchType.LAZY, cascade = { CascadeType.PERSIST, CascadeType.ALL, CascadeType.MERGE}, mappedBy = "payments")
    @JsonIgnore
    private List<ItineraryReservation> itineraryReservations;

    @PrePersist
    public void prePersist() {
        paymentDate = new Date();
    }
}
